Best Time to Buy and Sell Stock III

Problem Statement

You are given an array prices where prices[i] is the price of a given stock on the ith day.

Find the maximum profit you can achieve. You may complete at most two transactions.

Note: You may not engage in multiple transactions simultaneously (i.e., you must sell the stock before you buy again).

Example 1:

Input: prices = [3,3,5,0,0,3,1,4]
Output: 6
Explanation: Buy on day 4 (price = 0) and sell on day 6 (price = 3), profit = 3-0 = 3.
Then buy on day 7 (price = 1) and sell on day 8 (price = 4), profit = 4-1 = 3.

Example 2:

Input: prices = [1,2,3,4,5]
Output: 4
Explanation: Buy on day 1 (price = 1) and sell on day 5 (price = 5), profit = 5-1 = 4.
Note that you cannot buy on day 1, buy on day 2 and sell them later, as you are engaging multiple transactions at the same time. You must sell before buying again.

Example 3:

Input: prices = [7,6,4,3,1]
Output: 0
Explanation: In this case, no transaction is done, i.e. max profit = 0.

Constraints:

  • 1 <= prices.length <= 105

  • 0 <= prices[i] <= 105

Intuition

Just introduce another state number of tries (i.e is 2)

Becomes 3D Dp and solve as same as Earlier question

https://leetcode.com/problems/best-time-to-buy-and-sell-stock-iii/description/

https://www.youtube.com/watch?v=-uQGzhYj8BQ&ab_channel=takeUforward

Approach 1:

Memoization
C++
class Solution {
public:
    int find_ans(vector<int>& prices, int index, bool buy, int tries, 
    vector<vector<vector<int>>> &dp){
        if(index == prices.size() or tries == 0)
            return 0;

        if(dp[index][buy][tries] != -1)
            return dp[index][buy][tries];

        int profit;

        if(buy){
            profit = max( -prices[index] + find_ans(prices, index+1, false, tries, dp),
                            find_ans(prices, index+1, true, tries, dp) );
        }

        else{
            profit = max( +prices[index] + find_ans(prices, index+1, true, tries-1, dp),
                            find_ans(prices, index+1, false, tries, dp) );
        }

        return dp[index][buy][tries] = profit;
    }

    int maxProfit(vector<int>& prices) {
        int n = prices.size();
        int tries = 2;
        vector<vector<vector<int>>> dp(n, vector<vector<int>> (2, vector<int>(3,-1)));

        return find_ans(prices, 0, true, tries, dp);
    }
};

Approach 2:

Tabulation
C++
class Solution {
public:
    int maxProfit(vector<int>& prices) {
        int n = prices.size();
        vector<vector<vector<int>>> dp(n+1, vector<vector<int>> (2, vector<int>(3,0)));

        for(int index=n-1; index>=0; index--){
            for(int buy=0; buy<=1; buy++){
                for(int tries=1; tries<=2; tries++){
                    // Starting tries from 1 not 0 because it is base case condition
                    //At tries = 0 we return 0 as cannot buy  
                    int profit;
                    if(buy){
                        profit = max( -prices[index] + dp[index+1][0][tries],
                                        dp[index+1][1][tries]);
                    }

                    else{
                        profit = max( +prices[index] + dp[index+1][1][tries-1],
                                        dp[index+1][0][tries]);
                    }

                    dp[index][buy][tries] = profit;
                }
            }
        }

        return dp[0][1][2];
    }
};

Approach 3:

Space Optimized
C++
class Solution {
public:
    int maxProfit(vector<int>& prices) {
        int n = prices.size();
        vector<vector<int>> cur(2, vector<int>(3,0));
        vector<vector<int>> prev(2, vector<int>(3,0));


        for(int index=n-1; index>=0; index--){
            for(int buy=0; buy<=1; buy++){
                for(int tries=1; tries<=2; tries++){
                    // Starting tries from 1 not 0 because it is base case condition
                    //At tries = 0 we return 0 as cannot buy  
                    int profit;
                    if(buy){
                        profit = max( -prices[index] + prev[0][tries],
                                        prev[1][tries]);
                    }

                    else{
                        profit = max( +prices[index] + prev[1][tries-1],
                                       prev[0][tries]);
                    }

                    cur[buy][tries] = profit;
                }
            }
            prev = cur;
        }

        return prev[1][2];
    }
};

Approach 4:

C++
Can maintain a N*4(Transaction number) State
Instead of N*2(Buy)*3(Transaction count)

In this 

0 1 2 3
B S B S

On even tries you buy and odd you sell

Base Cases will be 

At trasaction number == 4 we return 0 

Similar Problems

Last updated